/* 
You can use various attributes along with your custom tags. 
To accept an attribute value, a custom tag class needs to implement
 the setter methods, identical to the JavaBean setter methods as shown below:
 */


package Example;

import javax.servlet.jsp.tagext.*;
import javax.servlet.jsp.*;
import java.io.*;

public class HelloAttributeTag extends SimpleTagSupport {
   private String message;

   public void setMessage(String msg) {
      this.message = msg;
   }
   StringWriter sw = new StringWriter();
   
   public void doTag() throws JspException, IOException {
      if (message != null) {
         /* Use message from attribute */
         JspWriter out = getJspContext().getOut();
         out.println( message );
      } else {
         /* use message from the body */
         getJspBody().invoke(sw);
         getJspContext().getOut().println(sw.toString());
      }
   }
}

/*
The attribute's name is "message", so the setter method is setMessage().
*/